<template>
	<mind-layout v-loading="loading">
		<template slot="toolbar-actions">
				<el-select v-model="configFile" 
					clearable filterable 
					placeholder="Seleccionar Archivo de Configuración" 
					@change="onChange">
					<el-option v-for="c in ConfigFiles" :label="c" :value="c" :key="c"/>
				</el-select>
		</template>
		<div class="container">
			<!-- {{recurso}} -->
			<div v-for="c in recurso" :key="c.category">
				<h2>
					[{{c.category}}]
					<el-button v-if="editable == ''" type="primary"  size="mini" icon="el-icon-edit" @click="editingData=c.options;editable = c.category" />
					<el-button v-if="editable == c.category" type="danger"  size="mini" icon="el-icon-close" @click="c.options = editingData; editable= ''" />
					<el-button v-if="editable == c.category" type="primary"  size="mini" icon="el-icon-check" @click="onSubmit(c.category, c.options)" />
					<el-button v-if="editable == ''" type="danger"  size="mini" icon="el-icon-delete" @click="delCategory(c.category)" />
				</h2>
				<asterisk-context :mode="editable==c.category ? 'raw' :'table'" :readonly="editable != c.category" v-model="c.options"  />
				
			</div>
			<div class="buttons">
				<el-button type="primary" icon="el-icon-plus" title="Nuevo Contexto/Categoría" circle
					v-if="configFile && editable == ''"  class="button-margin" @click="newCategory" />
			</div>
		</div>
		
	</mind-layout>
</template>

<script>
import {Rest} from '@/../modules/mind-core-vue'
import asteriskContext from '@/components/asterisk-context'
export default {
	components:{
		asteriskContext
	},
	created(){
		this.api = new Rest({
			uri: `api/ami/config-files`, 
			key: 'category'
		})
		this.fetchFileList()
	},
  computed: {
		ConfigFiles() {
			let list = [...this.configFiles]
			return list.sort()
		}
	},
	methods: {
		async fetchFileList() {
			// 	let api = new Rest({
			// 	uri: `api/ami/config-files/`, 
			// 	key: 'category'
			// })
			this.configFiles = await this.api.FetchAll()
			.catch((error)=>{
				this.$message({
					showClose: true,
					type: 'error',
					message: error
				});
			})
		},
		async onChange(v) {
			this.loading = true
			this.editable = ''
			if(v) {
				this.recurso = await this.api.Fetch(v)
				.catch((error)=>{
					this.$message({
						showClose: true,
						type: 'error',
						message: error
					});
				})
			} else {
				this.recurso = {}
			}
			this.loading = false
		},
		async onSubmit(cat, options) {
			const recurso = {
				category: cat,
				options: options
			}
			await this.api.Patch(recurso, `${this.configFile}/${cat}`)
				.then(()=>{
					this.onChange(this.configFile)
					this.$message({
						showClose: true,
						type: 'success',
						message: "Se aplicaron los cambios"
					})
				})
				.catch((error)=>{
					this.$message({
						showClose: true,
						type: 'error',
						message: error
					})
				})
			this.editable = ''
		},
		async newCategory() {
			this.$prompt('Nombre (sin espacios)', 'Crear Categoría/Contexto', {
					confirmButtonText: 'OK',
					cancelButtonText: 'Cancelar',
					inputPattern: /^[\w-_]+$/,
					inputErrorMessage: 'Nombre Inválido'
				}).then(async ({ value }) => {
					await this.api.Post({ category: value}, {uri: `${this.api.uri}/${this.configFile}`})
						.then(()=>{
							this.onChange(this.configFile)
							this.editable = value
							this.$message({
								showClose: true,
								type: 'success',
								message: "Se creó la categoría " + value
							})
						})
						.catch((error)=>{
							this.$message({
								showClose: true,
								type: 'error',
								message: error
							})
						})
				}).catch(() => {
					this.$message({
						showClose: true,
						type: 'info',
						message: 'Cancelado'
					});       
				});
		},
		delCategory(cat){
			this.$confirm(`Eliminar la Categoría ${cat}?`, 'Aviso', {
				confirmButtonText: 'Si',
				cancelButtonText: 'No',
				type: 'warning'
			}).then(async () => {
				await this.api.Delete(`${this.configFile}/${cat}`)
					.then(()=>{
						this.onChange(this.configFile)
						this.$message({
							showClose: true,
							type: 'success',
							message: "Se eliminó la categoría"
						})
					})
					.catch((error)=>{
						this.$message({
							showClose: true,
							type: 'error',
							message: error
						})
					})
			}).catch(() => {
				this.$message({
					showClose: true,
					type: 'info',
					message: 'Cancelado'
				});          
			});
		}
	},
	data() {
		return {
			recurso: {},
			configFile: "",
			editable: "",
			loading: false,
			editingData: {},
			//TODO: obtener lista de archivos de configuración en uso por asterisk (config list)
			configFiles: [
				'alsa.conf',
				'cel_odbc.conf',
				// 'dbsep.conf',
				'indications.conf',
				'pjproject.conf',
				'res_odbc.conf',
				'stasis.conf',
				'amd.conf',
				'cdr_manager.conf',
				'dsp.conf',
				'dundi.conf',
				'logger.conf',
				'pjsip.conf',
				'res_snmp.conf',
				'statsd.conf',
				'app_mysql.conf',
				'cdr_mysql.conf',
				'cel_tds.conf',
				'extconfig.conf',
				'manager.conf',
				'pjsip_notify.conf',
				'res_stun_monitor.conf',
				'test_sorcery.conf',
				'app_skel.conf',
				'cdr_odbc.conf',
				'cli.conf',
				'extensions.conf',
				'misdn.conf',
				'pjsip_wizard.conf',
				'resolver_unbound.conf',
				'ari.conf',
				'cli_aliases.conf',
				'features.conf',
				'modules.conf',
				'res_config_mysql.conf',
				'rtp.conf',
				'cdr_syslog.conf',
				'cli_permissions.conf',
				'func_odbc.conf',
				'musiconhold.conf',
				'res_config_sqlite.conf',
				'say.conf',
				'asterisk.conf',
				'cdr_tds.conf',
				'codecs.conf',
				'http.conf',
				'res_config_sqlite3.conf',
				'sip.conf',
				'cdr.conf',
				'cel.conf',
				'confbridge.conf',
				'iax.conf',
				'phone.conf',
				'res_corosync.conf',
				'sip_notify.conf',
				'cdr_adaptive_odbc.conf',
				'config_test.conf',
				'iaxprov.conf',
				'phoneprov.conf',
				'res_curl.conf',
				'sorcery.conf',
			]
		}
	}
}


</script>
<style lang="css" scoped>
	.buttons {
		float:right;
		margin-top: 15px;
		margin-right: 15px;
	}
	.button-margin {
		margin: 10px;
	}
</style>
<style >

.el-button--mini {
	padding: 5px 7px;
}

</style>
